﻿package{
	
	import flash.display.Sprite;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.events.MouseEvent;
	
	/*HORLOGE A FORMES GEOMETRIQUES*/
	/*INTRODUCTION DE LA NOTION DE DATE*/
	/*INTRODUCTION DE LA GESTION DES COULEURS EN HEXADECIMAL*/
	
	public class Clock extends Sprite{

		private var myTimer:Timer;
		private var now:Date;
		private var hourcolor:String;
		private var minutecolor:String;
		private var secondcolor:String;
		
		
		public function Clock():void{
			/*on établi des couleurs de référence*/
			chargeColor(null);
			/*on lance l'horloge*/
			startTimer();
			/*on ajoute la fonction de changement de couleurs au click*/
			stage.addEventListener(MouseEvent.CLICK,chargeColor);
			}
			
		private function startTimer():void{
			/*setup du timer toutes les secondes (1000 millisecondes)*/
			myTimer= new Timer( 1000, 0 );
			myTimer.addEventListener( TimerEvent.TIMER, updatehour );
			myTimer.start(); 
		}
		
		private function updatehour(Tevt:TimerEvent ){
			/*on efface tous les vecteurs de l'écran*/
			if(Tevt.currentTarget.currentCount !=1){
				while(numChildren>0) removeChildAt(0);
				};
			/*on récupère l'heure actuelle, heure, minutes, secondes*/
			now = new Date(); 
			var heure:String = reglage( now.hours );
			var minute:String = reglage( now.minutes );
			var seconde:String = reglage( now.seconds );
			
			/*on construit les formes suivant l'heure, on positionne sur l'écran, on affecte les couleurs*/
			
			
			shapeBuilder(Number(heure.substring(0,1)),30,100,hourcolor,"hours");
			shapeBuilder(Number(heure.substring(1,2)),30,175,hourcolor,"hoursa");
			
			shapeBuilder(Number(minute.substring(0,1)),30,250,minutecolor,"min");
			shapeBuilder(Number(minute.substring(1,2)),30,325,minutecolor,"mina");
			
			shapeBuilder(Number(seconde.substring(0,1)),30,400,secondcolor,"sec");
			shapeBuilder(Number(seconde.substring(1,2)),30,475,secondcolor,"seca");
			
			}
		/*on rajoute un 0 pour les valeurs en dessous de 10*/
		private function reglage( valeur:uint ):String{
			return (valeur<10) ? "0"+valeur : String(valeur);
		}
		
		private function chargeColor(e:MouseEvent):void{
			hourcolor = buildColor();
			minutecolor = buildColor();
			secondcolor = buildColor();
			}
		/*construction d'une valeur STRING pour une couleur aléatoire*/
		private function buildColor():String{
			var R:uint = Math.round(Math.random()*255);
			var G:uint = Math.round(Math.random()*255);
			var B:uint = Math.round(Math.random()*255);
			var nbr:uint =  R << 120 | G << 100 | B << 0;
			return "0x"+nbr.toString(12);
			}
		
		public function shapeBuilder(nbr:uint,X:uint,Y:uint,color:String,typ:String):void{
			
			var angle:Number;
			
			switch(typ){
				
				case "sec":
				
				if(nbr !=0){
					angle = 360/3;
				}
				if(nbr ==0){
					angle = 360/3;
				}
				
				X =30 + nbr*60;
				
				break;
				
				case "seca":
				
				if(nbr !=0){
					angle = 360/3;
				}
				if(nbr ==0){
					angle = 360/3;
				}
				
				X =30 + nbr*60;
				
				
				break;
				
				case "min":
				
				if(nbr !=0){
					angle = 360/3;
				}
				if(nbr ==0){
					angle = 360/3;
				}
				
				X =30 + nbr*60;
				
				break;
				
				case "mina":
				
				if(nbr !=0){
					angle = 360/3;
				}
				if(nbr ==0){
					angle = 360/3;
				}
				
				X =30 + nbr*60;
				
				break;
				
				case"hours":
				
				if(nbr !=0){
					angle = 360/3;
				}
				if(nbr ==0){
					angle = 360/3;
				}
				
				X =30 + nbr*60;
				
				break;
				
				case"hoursa":
				
				if(nbr !=0){
					angle = 360/3;
				}
				if(nbr ==0){
					angle = 360/3;
				}
				
				X =30 + nbr*60;
				
				break;
			
			}
				
				/*on définit une longueur de ligne aléatoire pour avoir un peu de mouvement	*/
				var longueur:uint =30;
				var myShape:Sprite = new Sprite();
				myShape.graphics.lineStyle(0,Number(color),.2);
				myShape.graphics.beginFill(Number(color),.5);
				myShape.graphics.moveTo(longueur,0);
				
				
				/*on dessine les forme d'après des principe de trigonométrie*/
				 for(var i:uint=0;i<360;i+=angle){
					 var posx:Number = Math.cos(Math.PI*i/180)*longueur;
					 var posy:Number = Math.sin(Math.PI*i/180)*longueur;
					 if(i!=0){
						 myShape.graphics.lineTo(posx,posy);
						
					 	}
					 }
				myShape.graphics.lineTo(longueur,0);
			
				myShape.x=X;
				myShape.y=Y;
				/*petit tricks pour le 1 qui n'a pas de valeur d'angle*/
					myShape.rotation = (now.seconds)*6;
					
					
					
				/*on ajoute la forme à l'écran*/
				addChild(myShape);
			//}
			
			}
		}
	}